--[[============================================================================
main.lua
============================================================================]]--

-- Placeholder for the dialog
local dialog = nil

-- Placeholder to expose the ViewBuilder outside the show_dialog() function
local vb = nil

-- Reload the script whenever this file is saved. 
-- Additionally, execute the attached function.
_AUTO_RELOAD_DEBUG = function()
  
end

-- Read from the manifest.xml file.
class "RenoiseScriptingTool" (renoise.Document.DocumentNode)
  function RenoiseScriptingTool:__init()    
    renoise.Document.DocumentNode.__init(self) 
    self:add_property("Name", "Untitled Tool")
    self:add_property("Id", "Unknown Id")
  end

local manifest = RenoiseScriptingTool()
local ok,err = manifest:load_from("manifest.xml")
local tool_name = manifest:property("Name").value
local tool_id = manifest:property("Id").value

--------------------------------------------------------------------------------
-- Main functions
--------------------------------------------------------------------------------
--variables-------------------------------------------

--is line not empty checker function
  local function isLineEmpty(lineID, columnID, patTrack)
    --local patTrack = renoise.song().selected_pattern_track
     local deviceString = patTrack:line(lineID).effect_columns[columnID].number_string
    -- Check if the line is not empty
        if deviceString ~= "00" then
          return false
        else
        return true
        end
    end

--interpolator
local function interpolate(stepCounter, startValue, endValue, curStep)
        return (startValue) + ((curStep / stepCounter) * (endValue-startValue))
end

    --establish parameter value from device based on first value
local function parameterOldFunc(trackID,deviceString)
    local deviceID = 1
    local deviceStringSplit = 1
    local deviceParamID 
    local parameterOld =1
      if deviceString ~= "00" then
   deviceID = tonumber(string.sub(deviceString, 1, 1))+1
   deviceStringSplit = tonumber(deviceString:sub(2))
   deviceParamID = renoise.song().tracks[trackID].devices[deviceID].parameters[deviceStringSplit]
    parameterOld = math.floor((255 / (deviceParamID.value_max - deviceParamID.value_min)) * (deviceParamID.value - deviceParamID.value_min) + 0.5)     --gets the value of the parameter on the device currently
    return parameterOld
else
return nil
  end
end

--main function
local function InterpolateBeyond()
    -- Initialize the variables
    print("____INTERPOLATE___")
    local track = renoise.song().selected_track
    local lineID = renoise.song().selected_line_index--variable for the first line
    local trackID = renoise.song().selected_track_index
    local patternID = renoise.song().selected_pattern_index
    local columnID = renoise.song().selected_effect_column_index
    if columnID == 0 then --only runs if run on an effect column
    columnID = columnID+1
    end
    --if not isLineEmpty(lineID,columnID,patTrack) then 
    local patternLength = renoise.song().patterns[patternID].number_of_lines
    local patternLengthPrev
    local parameter = renoise.song().selected_parameter 
    local patCount= #renoise.song().patterns
    local stepCounter = 0
    local curStep = 1
    local endOfProject = false
    local beginningOfProject = false
--    local parameterID = renoise.song().selected_automation_parameter
    --if parameterID ~= "00" then
    --print("line ID  "..lineID)
    
  --find previous point  
  while isLineEmpty(lineID,columnID,renoise.song().patterns[patternID]:track(trackID))  do
  --print("patternID"..patternID)
 -- print("line id"..lineID)
        lineID = lineID - 1

          if lineID == 0 then
             patternID = patternID-1
                       if patternID ==0  then
          print("beginning of song")
          patternID= 1
          beginningOfProject = true
          lineID = 1
          break
          end
             patternLengthPrev = renoise.song().patterns[patternID].number_of_lines
      --  print("pattern length prev   "..patternLengthPrev)
             lineID = patternLengthPrev
          end

          end

     --     lineID = lineUp
     -- print("First Line ID"..lineID)
--print("patternID  "..patternID)
--print("pattern length        "..patternLength)

           --if check point is last line of pattern, this keeps it from failing
           local lineDown = lineID+1
           local patternNext = patternID --patternID == start point pattern
           if patternLengthPrev == nil then
           patternLengthPrev = patternLength
            end
      if lineDown > patternLengthPrev then
      lineDown = 1
      patternNext = patternID+1
      end
--Find next modulation point
  while isLineEmpty(lineDown,columnID,renoise.song().patterns[patternNext]:track(trackID))  do
        --print("step counter earlier   "..stepCounter)
       -- print(lineDown)
        lineDown = lineDown + 1
        stepCounter = stepCounter+1
        patternLength = renoise.song().patterns[patternNext].number_of_lines
          if lineDown == patternLength+1 then
             patternNext = patternNext+1
             lineDown = 1
          end
          if patternNext > patCount then
          patternNext = patternNext-1
          endOfProject = true
          print("end of project")
          stepCounter = stepCounter-1
          break
          end
          end   
          --print(lineDown)    
    --get current device parameter value in byte
    local patTrack = renoise.song().patterns[patternID]:track(trackID)
    local deviceString = patTrack:line(lineID).effect_columns[columnID].number_string
    local patTrackNext =renoise.song().patterns[patternNext]:track(trackID)
    local deviceStringEnd = patTrackNext:line(lineDown).effect_columns[columnID].number_string
    
        --get beginning values
        local parameterStart 
    if beginningOfProject == false then
    parameterStart = renoise.song().patterns[patternID]:track(trackID):line(lineID).effect_columns[columnID].amount_value
    else
    parameterStart = parameterOldFunc(trackID,deviceStringEnd)
    end
    --get end values
        local parameterEnd
    if endOfProject == false then
    parameterEnd = renoise.song().patterns[patternNext]:track(trackID):line(lineDown).effect_columns[columnID].amount_value
    else
    parameterEnd = parameterOldFunc(trackID,deviceString)
    end
           --if check point is last line of pattern, this keeps it from failing
            lineDown = lineID+1
            patternNext = patternID --patternID == start point pattern
           --  print("pattern next first"..patternNext)
            -- print("line down first"..lineDown)
            patternLength = renoise.song().patterns[patternID].number_of_lines
           -- print("pattern length"..patternLength)
      if lineDown > patternLength then
      lineDown = 1
      patternNext = patternID+1
      end
      if beginningOfProject then
      lineDown = 1
      curStep = 0
      stepCounter = stepCounter-1
      deviceString =deviceStringEnd
      end
          -- print("line down"..lineDown)
         -- print("pattern ID"..patternID)
-- print("pattern next"..patternNext)
  stepCounter = stepCounter+1
--print("stepCounter     "..stepCounter)

  --interpolate value at each point
  if beginningOfProject and endOfProject then
  else
    while isLineEmpty(lineDown,columnID,renoise.song().patterns[patternNext]:track(trackID)) do
      local stepValue = interpolate(stepCounter, parameterStart, parameterEnd, curStep)
              patternLength = renoise.song().patterns[patternNext].number_of_lines
       renoise.song().patterns[patternNext]:track(trackID):line(lineDown).effect_columns[columnID].amount_value = stepValue
       renoise.song().patterns[patternNext]:track(trackID):line(lineDown).effect_columns[columnID].number_string = deviceString
       lineDown = lineDown + 1
       curStep = curStep+1
          if lineDown == patternLength+1 then
             patternNext = patternNext+1
             lineDown = 1
          end
           if patternNext > patCount then --ends loop if it gets to the end of available patterns
          break
          end
    end
  end
end
--end
--end
--------------------------------------------------------------------------------
-- Menu entries
--------------------------------------------------------------------------------
--[[
renoise.tool():add_menu_entry {
  name = "Main Menu:Edit:"..tool_name,
  invoke = ParameterLock
}
--]]

--------------------------------------------------------------------------------
-- Key Binding
--------------------------------------------------------------------------------


renoise.tool():add_keybinding {
  name = "Global:Tools:" .. tool_name,
  invoke = InterpolateBeyond
}

